/***************************************************************************/
/* 	This code is part of X-toolkit widget library called Nws 	   */
/*	Copyright (c) 1997,1998,1999 Ondrejicka Stefan			   */
/*	(ondrej@idata.sk)						   */
/*	Distributed under GPL 2 or later				   */
/***************************************************************************/

#ifndef _FloatEntryP_H_
#define _FloatEntryP_H_

#include <Nws/EntryLineP.h>
#include <Nws/FloatEntry.h>

typedef struct {
	char empty;
} FloatEntryClassPart;

typedef struct _FloatEntryClassRec {
	CoreClassPart		core_class;
	BaseClassPart		base_class;
	EntryLineClassPart	entryLine_class;
	FloatEntryClassPart	floatEntry_class;
} FloatEntryClassRec;

extern FloatEntryClassRec 	floatEntryRec;

typedef struct {
	/* resources */
	int		decimals;
	float		value;
	int		arrow_width;
	float		increment;
	float		maxval;
	float		minval;
	/* private */
	XtIntervalId	timer;
	Boolean		active_arrows;
	int		arrow;
	char		*oldtext;
} FloatEntryPart;

typedef struct _FloatEntryRec {
	CorePart		core;
	BasePart		base;
	EntryLinePart		entryLine;
	FloatEntryPart		floatEntry;
} FloatEntryRec;

#endif
